﻿B4R=true
Group=Default Group
ModulesStructureVersion=1
Type=StaticCode
Version=4
@EndOfDesignText@


Sub Process_Globals
	Private Blue_T				As ESP32Bluetooth							' Libreria BlueTooth
	Private astream 			As AsyncStreams								' Comunicaciones Serie del BlueTooth
	
	Private Cnt_BT 				As Long 
End Sub

'
' Inicializa la Conexion BlueTooth
Public Sub Inicializa_Blue
	Dim Ayuda As String
	Dim Blue_Name As String = "Multi-Generador"
	Log("Inicializando BlueTooth en Curso")
	Log("Nombre:",Blue_Name)
		
	If Blue_T.Connected = True Then
		Blue_T.Close		'
		Log("Cierra Conexion")
	End If
	If Blue_T.Initialize(Blue_Name, "Blue_T_CambioEstado") = False Then	'
		Log("Fallo Iniciando BlueTooth")							'
	Else
		astream.Initialize(Blue_T.Stream, "Blue_T_NewData", "Blue_T_Error")
		Log("BlueTooth Iniciando Correctamente")
		Ayuda = JoinStrings(Array As String("Nombre BlueTooth = ",Blue_Name))
		Log(Ayuda)
	End If
End Sub
'
' Cambio del Estado de la Conexion BlueTooth
Sub Blue_T_CambioEstado (Connected As Boolean)
	If Connected = False Then
		Blue_T.Close
		Inicializa_Blue
	End If
	Log("Cambio Estado BLUETOOTH ",Connected)
End Sub
'
' Errores en la Comunicacion BlueTooth
Sub Blue_T_Error
	Log("ERROR BLUETOOTH ... Blue_T_ERROR")
End Sub
'
' Telegramas de Entrada en la Comunicacion BlueTooth
Sub Blue_T_NewData (Buffer() As Byte)
	Dim T()		As Byte = Buffer
	Dim Tt		As String
	
	Cnt_BT = Cnt_BT + 1
	
	Tt = Main.BC.StringFromBytes(T)
	Log(Cnt_BT,"->",Tt)
	Envia_Blue_T(Tt)
	
				
End Sub
'
' Envia por BlueTooth 
Public Sub Envia_Blue_T(Texto As String)
	Dim L(4)		As Byte					' Auxiliar de Longuitud
	Dim Largo 		As Int	= 0				' Longuitud del Telegrama Enviado
	
	Largo = Texto.Length					' Largo del Telegrama
	
	L(1) = Largo / 256
	L(0) = Largo - (L(1) * 256)
	L(2) = 0
	L(3) = 0

	astream.Write(L)						' Cabecera de Longuitud
	astream.Write(Texto.GetBytes)			' Telegrama
	
End Sub
